<template>
    <div class="header__user">
        <div class="header__user guest">
            <a v-on:click="toggleRegistrationModal" class="header__user_text">
                <i class="svg-ui-icon">
                    <svg width="16" height="16" viewBox="0 0 14 16" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path
                            d="M7.00002 6C7.79567 6 8.55873 5.68393 9.12134 5.12132C9.68395 4.55871 10 3.79565 10 3C10 2.20435 9.68395 1.44129 9.12134 0.87868C8.55873 0.316071 7.79567 0 7.00002 0C6.20437 0 5.4413 0.316071 4.8787 0.87868C4.31609 1.44129 4.00002 2.20435 4.00002 3C4.00002 3.79565 4.31609 4.55871 4.8787 5.12132C5.4413 5.68393 6.20437 6 7.00002 6ZM0.465016 12.493C0.372181 12.7411 0.361939 13.0126 0.435813 13.267C0.509687 13.5214 0.663728 13.7452 0.875016 13.905C2.62635 15.266 4.782 16.0034 7.00002 16C9.31002 16 11.438 15.216 13.131 13.9C13.561 13.567 13.735 12.997 13.539 12.49C13.0313 11.168 12.1346 10.0311 10.9673 9.22922C9.80008 8.42737 8.41712 7.99829 7.00098 7.99861C5.58485 7.99894 4.20209 8.42865 3.03521 9.23104C1.86833 10.0334 0.972174 11.1708 0.465016 12.493Z"
                            fill="#7D2AEB"/>
                    </svg>
                </i> <span>Личный кабинет</span>
            </a>
        </div>

        <modal :name="registrationModal" :adaptive="Boolean" :maxWidth="500" height="auto" styles="border-radius: 10px" classes="auth-form form-ui-style-default">
            <div class="registration-form step-1">
                <div class="form__title">Войти или зарегистрироваться</div>

                <div class="form-group">
                    <label for="email">Номер телефона <i class="requred">*</i></label>
                    <phone-input
                        v-model:value="phone"
                    />
                </div>

                <div v-if="errors.length" class="form-validation-errors alert alert-danger">
                    <div v-for="error in errors">
                        {{ error }}
                    </div>
                </div>

                <div class="form-group">
                    <label class="label-accept-text">
                        Нажимая «Далее», вы соглашаетесь с <a target="_blank" href="/userterms/">правилами сайта</a> и  <a target="_blank" href="/userpolitics/">политикой обработки персональных данных</a>.
                    </label>
                </div>

                <div class="form-group">
                    <div class="d-flex justify-content-between form__buttons align-items-center">
                        <button name="next_stage" v-on:click="nextStage" class="btn btn-primary">
                            Далее
                        </button>
                    </div>
                </div>
            </div>
        </modal>

        <modal :name="secondStage" :adaptive="Boolean" :maxWidth="500" height="auto" styles="border-radius: 10px" classes="auth-form form-ui-style-default">
            <div class="form__title">{{ secondStageTitle }}</div>

            <div class="form-group form-text-info">
                Сейчас вам поступит звонок. <br/>
                Поднимите трубку, прослушайте код и введите его в поле ниже.
            </div>

            <div class="form-group">
                <label for="email">Код подтверждения<i class="requred">*</i></label>

                <input
                    class="form-control phone-input"
                    v-model="code"
                    name="code"
                    id="code"
                >
            </div>

            <div v-if="attemptsLeft !== 5 && ! errors.length" class="form-validation-errors alert alert-danger">
                {{ attemptsLeftMessage }}
            </div>
            <div v-if="errors.length" class="form-validation-errors alert alert-danger">
                <div v-for="error in errors">
                    {{ error }}
                </div>
            </div>

            <div class="form-group">
                <div class="d-flex justify-content-between form__buttons align-items-center">
                    <button v-on:click="confirmCode" class="btn btn-primary">
                        Отправить
                    </button>
                </div>
            </div>
        </modal>

        <modal :name="userInfoModal"  :adaptive="Boolean" :maxWidth="500" height="auto" styles="border-radius: 10px"  classes="auth-form form-ui-style-default">
            <div class="form__title">Расскажите о себе</div>

            <div class="form-group form-text-info">
                Эти данные нужны для работы на сайте и связи с заказчиками.
            </div>

            <div class="form-group">
                <label for="name">Как Вас зовут? <i class="requred">*</i></label>

                <input
                    type="text"
                    v-model="userName"
                />
            </div>

            <div class="form-group">
                <label for="name">Электронная почта <i class="requred"></i></label>

                <input
                    type="email"
                    v-model="userEmail"
                />
            </div>

            <div v-if="errors.length" class="form-validation-errors alert alert-danger">
                <div v-for="error in errors">
                    {{ error }}
                </div>
            </div>

            <div class="form-group">
                <div class="d-flex justify-content-between form__buttons align-items-center">
                    <button class="btn btn-primary" v-on:click="registerUser">
                        Отправить
                    </button>
                </div>
            </div>
        </modal>
    </div>
</template>

<script>
import {computed, ref} from "vue";

export default {
    data() {
        return {
            registrationModal: `registration-modal`,
            loginModal: `login-modal`,
            secondStage: `second-stage-modal`,
            userInfoModal: `user-info-modal`,
            errors: [],
            callId: '',
            code: '',
            userName: '',
            userEmail: '',
            attemptsLeft: 5
        }
    },
    computed: {
        attemptsLeftMessage() {
           return `Неверный код (осталось попыток: ${this.attemptsLeft})`;
       },
    },
    setup() {
        const phone = ref('');
        const profileButton = ref('');
        const code = ref('');

        const secondStageTitle = computed(() => `Звоним на номер ${phone.value}`);

        return { phone, profileButton, secondStageTitle, code };
    },
    methods: {
        toggleRegistrationModal() {
            this.errors = [];
            this.toggleModal(this.registrationModal);
        },
        showUserInfoModal() {
            this.errors = [];
            this.toggleModal(this.secondStage);
            this.toggleModal(this.userInfoModal);
        },
        toggleModal(modalName) {
            this.errors = [];
            this.code = '';
            this.attemptsLeft = 5;
            this.$modal.toggle(modalName);
        },
        async nextStage() {
            this.errors = [];
            await axios
                .post('/makeCall/', { phone: this.phone })
                .then(result => {
                    this.toggleModal(this.registrationModal);
                    this.toggleModal(this.secondStage);
                    this.callId = result.data.data.id;
                })
                .catch(error => {
                    if (error.response) {
                        if (error.response.data.data.code == 'clientError') {
                            this.errors = this.errors.concat([error.response.data.data.message]);
                        } else {
                            this.errors = error.response.data.data.errors.phone;
                        }
                    } else {
                        console.error(error);
                    }
                })
            ;
        },
        async confirmCode() {
            this.errors = [];
            await axios
                .post('/login/', { code: this.code, phone: this.phone, callId: this.callId })
                .then(result => {
                    if (result.data.data?.message == 'notValidCode') {
                        if (--this.attemptsLeft === 0) {
                            this.toggleModal(this.secondStage);
                        }
                    } else if (result.data.data?.message == 'notFound') {
                        this.showUserInfoModal();
                    } else {
                        window.location.href = result.request.responseURL;
                    }
                })
                .catch(error => {
                    this.errors = error.response.data.data.errors.code;
                })
            ;
        },
        async registerUser() {
            this.errors = [];
            await axios
                .post('/register/', { phone: this.phone, name: this.userName, email: this.userEmail })
                .then((response) => {
                  if (this.userEmail) {
                    this.sendEmailConfirmation();
                  }

                  window.location.href = response.request.responseURL;
                })
                .catch(error => {
                  if (error.response.data.data.errors.name && error.response.data.data.errors.email) {
                    this.errors = [...this.errors, ...error.response.data.data.errors.name, ...error.response.data.data.errors.email];
                  } else if (error.response.data.data.errors.name) {
                    this.errors = [...this.errors, ...error.response.data.data.errors.name];
                  } else if (error.response.data.data.errors.email) {
                    this.errors = [...this.errors, ...error.response.data.data.errors.email];
                  }
                })
            ;
        },
        sendEmailConfirmation() {
          axios
              .post('/email/send-verification/', { email: this.userEmail })
              .catch(error => {
                console.error(error);
              })
          ;
        },
    },
}
</script>
